/*

* FreeRTOS for AVR Small demo / Mega Pack *
  

http://avr.paslog.jp/article/1157172.html
2009/06/27 by audin
  
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include "portmacro.h"
#include "FreeRTOS.h"
#include "task.h"

/* ATmega-Changes */ 
#if defined(__AVR_ATmega8__)|| defined(__AVR_ATmega16__)|| defined(__AVR_ATmega323__)
#define	UBRR0H  UBRRH 
#define	UBRR0L  UBRRL 
#define	UCSR0A  UCSRA 
#define	UCSR0B  UCSRB 
#define	UDR0    UDR	
#define	RXEN0   RXEN 
#define	TXEN0   TXEN 
#define	UCSR0C  UCSRC 
#define	UCSZ00 UCSZ0 					//UCSZ1:0=11 f[^rbg8
#define	USBS0   USBS
#define	UPM00   UPM0
#define	UCSR0A  UCSRA 
#define	UDRE0   UDRE 
#endif



#define FOSC configCPU_CLOCK_HZ					// 8MHz
#define BAUD 38400
#define MYUBRR  ((FOSC)/16/BAUD)-1			// UART
void sio_set(unsigned int baud);
void sio_puts(PGM_P buf);
void sio_init(void);

/*******************

* sio_set
  
 *******************/
void sio_set(unsigned int baud)
{
	UBRR0H = (unsigned char)(baud>>8);	// {[[g
	UBRR0L = (unsigned char)baud;		// {[[g
	UCSR0B = (1<<RXEN0)|(1<<TXEN0);		// M
#if defined(__AVR_ATmega8__)
	UCSRC = (1<<URSEL)|(3<<UCSZ0)|(0<<USBS)|(0<<UPM0);
#else
	UCSR0C = (3<<UCSZ00)|(0<<USBS0)|(0<<UPM00);
#endif
}
/*******************

* sio_puts
  
 *******************/
void sio_puts(PGM_P buf)
{ 
	while( pgm_read_byte(buf) ){
		while ( !(UCSR0A & (1<<UDRE0)) );	// Mޯ̧󂫑ҋ@
		UDR0 = pgm_read_byte(buf++);
	  	vTaskDelay( 60 / portTICK_RATE_MS);
	}
}
/*******************

* sio_init
  
 *******************/
void sio_init(void)
{
	sio_set(MYUBRR);
}
