/*

* FreeRTOS for AVR Small demo / Mega Pack *
  

http://avr.paslog.jp/article/1157172.html
2009/06/27 by audin
  
*/

/* Scheduler include files. */
#include <avr/pgmspace.h>
#include "FreeRTOS.h"
#include "task.h"
extern void sio_puts(PGM_P buf);
void vSio_Task( void *pvParameters );

static unsigned char state=1;

const char PROGMEM MSG_CLR[]	= /* 0 */ "\x1b[2J";	//clear 
const char PROGMEM MSG1[]	= /* 1 */ "FreeRTOS for AVR Realtime UART Tranfer test. \n\r";
const char PROGMEM MSG2[]	= /* 2 */ "CPU may be ATmega8, or something.\n\r";
const char PROGMEM MSG3[]	= /* 3 */ "Welcome !\n\r";
const char PROGMEM MSG4[]	= /* 4 */ "UART speed is 38400 bps.\n\r"  ;
const char PROGMEM MSG_CR[]	= /* 4 */ "\n\r"  ;

#define  msgClr MSG_CLR
#define  msg1 MSG1
#define  msg2 MSG2
#define  msg3 MSG3
#define  msg4 MSG4
#define  msgCR MSG_CR



/*******************

* vSio_Task
  
 *******************/
void vSio_Task( void *pvParameters )
{
  ( void ) pvParameters;	// not used

  sio_puts(msgClr);				//clear 
  while(1){
	switch(state){
		case 0:
			sio_puts(msg1);
	  		vTaskDelay( 2000 / portTICK_RATE_MS);	  
			sio_puts(msg2);
			sio_puts(msgCR);
	  		vTaskDelay( 2000 / portTICK_RATE_MS);
			state = 1;
			break;
		case 1:
			sio_puts(msg3);
			vTaskDelay( 2000 / portTICK_RATE_MS);
			state = 2;
			break;
		case 2:
			sio_puts(msg4);
			vTaskDelay( 2000 / portTICK_RATE_MS);
			state = 0;
			break;
	}
  }
}
